import java.awt.Color;
/**
 * A textual view of the simulation. 
 * After each step of the simulation it prints out the stats
 * 
 * @author Poul Henriksen
 * @version 2005.03.15
 */
public class TextView  implements SimulatorView
{
    // A statistics object computing and storing simulation information
    private FieldStats stats;

    /**
     * Create a view
     */
    public TextView()
    {
        stats = new FieldStats();
    }
    
    /**
     * Not used in this type of view.
     */
    public void setColor(Class animalClass, Color color)
    {
    }

    

    /**
     * Show the current status of the field.
     * @param step Which iteration step it is.
     * @param field The field whose status is to be displayed.
     */
    public void showStatus(int step, Field field)
    {
        stats.reset();
        for(int row = 0; row < field.getDepth(); row++) {
            for(int col = 0; col < field.getWidth(); col++) {
                Object animal = field.getObjectAt(row, col);
                if(animal != null) {
                    stats.incrementCount(animal.getClass());
                }
            }
        }
        stats.countFinished();

        System.out.println(stats.getPopulationDetails(field));
    }

    /**
     * Determine whether the simulation should continue to run.
     * @return true If there is more than one species alive.
     */
    public boolean isViable(Field field)
    {
        return stats.isViable(field);
    }
}
